﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Mono.Cecil;
using NETDeob.Engine.Utils;
using NETDeob.Misc;
using NETDeob.Misc.Structs__Enums___Interfaces.Deobfuscation;
using de4dot.blocks.cflow;

namespace NETDeob.Deobfuscators.Generic
{
    class MethodCleaner2 : DeobfuscationTask
    {
        public MethodCleaner2(AssemblyDefinition asmDef)
            : base(asmDef)
        {
        }

        [DeobfuscationPhase(1, "Clean Control Flow (de4dot)")]
        public static bool Phase1()
        {
            var cflowCleaner = new CflowDeobfuscator();
            var mCounter = 0;

            foreach (var mDef in AsmDef.FindMethods(m => true))
            {
                cflowCleaner.deobfuscate(mDef);
                mCounter++;

                Logger.VLog("Cleaned method: " + mDef.Name);
            }

            Logger.VSLog(string.Format("{0} methods cleaned...", mCounter));
            return true;
        }
    }
}
